unit mod_external;

{

   COPYRIGHT 2017 Blue Hell / Jan Punter

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License version 2 as
  published by the Free Software Foundation;

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

  For all listed email addresses :

    _dot. to be substituted by a dot      '.'
    2@t2  to be substituted by an at sign '@'


  Blue Hell is a trade mark owned by

    Jan Punter
    Oogstplein 6
    7545 HP Enschede
    the Netherlands
    http://www.iaf.nl/Users/BlueHell/
    http://bluehell.electro-music.com/
    j_dot.punter2@t2iaf_dot.nl

  All rights attributed to Blue Hell are owned by Jan Punter.




  = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = =
  = = DOCS  = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = =
  = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = =


  ** Record field alignment for passed data structures ( is / should be) set to quad-word (8 bytes).


  ** The functions external code (sh|c)ould implement:

    . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .

    procedure GetCaps( var IsInput, IsOutput, IsSlow, IsMidi, IsOSC: Integer); cdecl;
    void __cdecl GetCaps( int * IsInput, int * IsOutput, int * IsSlow, int * IsFast, int * IsMidi, int * IsOSC);

      Called to get information about what the external code implements.


    . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .

    procedure Create( const aName: AnsiString); cdecl;
    void __cdecl Create( AnsiChar * aName);

      Called during creation of a module, during this call no DoTick or DoSlowTick calls will b made to the external
      code. The external code should use this to set up it's internal data sructures.


    . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .

    procedure Destroy; cdecl;
    void __cdecl Destroy( void);

      Called during destruction of a module, during or after this call no DoTick or DoSlowTick calls will be made to the
      external code. The external code should use this to clean up it's internal data structures.


    . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .

    procedure SetDefaults; cdecl;
    void __cdecl SetDefaults( void);

      Called during module setup, external code may use this to set up it's default values.


    . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .

    procedure SampleRateChanged( aSystemRate, aControlRate: Double); cdecl;
    void __cdecl SampleRateChanged( double aSystemRate, double aControlRate);

      Called when the samplerate was changed, during this call no calls will be made to DoTick or DoSlowTick. The
      external code can use this to recalculate sample rate dependent data.


    . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .

    procedure TuningChanged( const aReferenceA, aNotesPerOctave, aMiddleNote: Double); cdecl;
    void __cdecl( double aReferenceA, double aNotesPerOctave, double aMiddleNote);

      Called when the system tuning was changed, during this call no calls will be made to DoTick or DoSlowTick. The
      external code can use this to recalculate sample tuning dependent data.


    . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .

    procedure SetStringValue( const aName: AnsiString; const aValue: AnsiString); cdecl;
    void __cdecl SetStringValue( AnsiChar * aName, AnsiChar * aValue);

      Called when a string value changed in the user interface, or during patch initiaiztion.


    . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .

    function  GetStringValue( const aName: AnsiString): PAnsiString; cdecl;
    AnsiChar * __cdecl GetStringValue( AnsiChar * aName);

      Called when the user interface wants to know about a string value. Is this ever? hmm ...


    . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .

    procedure SetInternal( const aName: AnsiString; const aValue: Double); cdecl;
    void __cdecl SetInternal( AnsiChar * aName, double aValue);

      Called when an internal value changed in the user interface, this can be a knob, a fader, a selector etc.


    . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .

    function  GetInternal( const aName: AnsiString): Double; cdecl;
    double __cdecl GetInternal( AnsiChar * aName);

      Called when th user interface wants to know a parameter value for a knob, a fader, a selector etc. Is this ever?
      hmm ...


    . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .

    procedure DoTick( const anInputs: PExtData; const anOutputs: PExtData); cdecl;
    void __cdecl DoTick( TExtData * anInputs, TExtData * anOutputs);

      Called from the audio thread at the system rate when the synth engine wants the module to compute new output
      values. This will only be called when IsFast is true. IsFast should not be set for sped up modules.


    . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .

    procedure DoSlowTick( const anInputs: PExtData; const anOutputs: PExtData); cdecl;
    void __cdecl DoTick( TExtData * anInputs, TExtData * anOutputs);

      Called from the audio thread at the audio rate or the control rate when the synth engine wants the module to
      compute new output values. This will only be called when IsSlow is true. When the module is sped up it will be
      called at the audio rate, otherwise at the control rate. IsFast should not be set for sped up modules.


    . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .

    function InputName( const anIdex: Integer): PAnsiString; cdecl;
    AnsiChar * __cdecl InputName( int anIndex);

      Called by the system to make a connection between an input index (as used in the tick methods) and the name of
      that input.


    . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .

    function  OutputName( const anIdex: Integer): PAnsiString; cdecl;
    AnsiChar * __cdecl OutputName( int anIndex);

      Called by the system to make a connection between an output index (as used in the tick methods) and the name of
      that output.


    . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .

    function  GetSignalCount: Integer; cdecl;
    int __cdecl GetSignalCount( void);

      Called by the system to get the number of Signals in the user interface that the external code wishes to update.
      Signals are Double values that get printed out as text in the user interface.


    . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .

    function  GetLightsCount: Integer; cdecl;
    int __cdecl GetLightsCount( void);

      Called by the system to get the number of Light in the user interface that the external code wishes to update.
      Lights are binary items that can be either on or off typically LED indicators on modules.


    . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .

    function  GetDataCount: Integer; cdecl;
    int __cdecl GetDataCount( void);

      Called by the system to get the number of Data elements (for instance for a graph) in the user interface that the
      external code wishes to update.


    . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .

    function  GetXYDataCount: Integer; cdecl;
    int __cdecl GetXYDataCount( void);

      Called by the system to get the number of X Y Data elements (currently only used for the XYScope module) in the
      user interface that the external code wishes to update.


    . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .

    function  GetInfoCount: Integer; cdecl;
    int __cdecl GetInfoCount( void);

      Called by the system to get the number of Info elements in the user interface that the external code wishes to
      update. Info elementsa have a string value.


    . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .

    function  GetCursorCount: Integer; cdecl;
    int __cdecl GetCursorCount( void);

      Called by the system to get the number of Cursor elements in the user interface that the external code wishes to
      update. A cursoe element consists of an X, Y pair. Currently this is used for the DataGraph like modules.


    . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .

    procedure GatherSignals( const anIndex: Integer; out aData: PExtData); cdecl;
    void __cdecl GatherSignals( int anIndex, TExtData * aData);

      Called by the system GetSignalCount times to actually obtain the values. The external code should fill up a
      TExtData structure for passing the data. After the call the external code may free that structure.


    . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .

    procedure GatherLights( const anIndex: Integer; out aData: PExtData); cdecl;
    void __cdecl GatherLights( int anIndex, TExtData * aData);

      Called by the system GetLightsCount times to actually obtain the values. The external code should fill up a
      TExtData structure for passing the data. After the call the external code may free that structure.


    . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .

    procedure GatherData( const anIndex: Integer; out aData: PExtData); cdecl;
    void __cdecl GatherData( int anIndex, TExtData * aData);

      Called by the system GetDataCount times to actually obtain the values.The external code should fill up a
      TExtData structure for passing the data. After the call the external code may free that structure.


    . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .

    procedure GatherXYData( const anIndex: Integer; out aData: PExtPairData); cdecl;
    void __cdecl GatherXYData( int anIndex, TExtPairData * aData);

      Called by the system GetXYDataCount times to actually obtain the values. The external code should fill up a
      TExtPairData structure for passing the data. After the call the external code may free that structure.


    . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .

    procedure GatherInfo( const anIndex: Integer; out aData: PExtStringData); cdecl;
    void __cdecl GatherInfo( int anIndex, TExtStringData * aData);

      Called by the system GetInfoCount times to actually obtain the values. The external code should fill up a
      TExtStringData structure for passing the data. After the call the external code may free that structure.


    . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .

    procedure GatherCursorData( const anIndex: Integer; out aData: PExtData); cdecl;
    void __cdecl GatherCursorData( int anIndex, TExtData * aData);

      Called by the system GetCursorCount times to actually obtain the values. The external code should fill up a
      TExtData structure for passing the data. After the call the external code may free that structure.


    . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .

}


interface

uses

  WinApi.Windows, System.SysUtils,

  KnobsUtils, KnobsConversions, ComplexMath, module_defs;

type

  TDoublePair   = record X: Double; Y: Double; end;
  TLongData     = array[ 0 .. MaxInt div SizeOf( Double) - 1] of Double;
  TLongPairData = array[ 0 .. MaxInt div SizeOf( TDoublePair) - 1] of TDoublePair;

  PLongData     = ^ TLongData;
  PLongPAirData = ^ TLongPairData;

  TExtData = record
    Name  : PAnsiString;
    Count : Integer;
    Data  : array[ 0 .. 0] of Double;
  end;
  PExtData = ^ TExtData;

  TExtPairData = record
    Name  : PAnsiString;
    Count : Integer;
    Data  : array[ 0 .. 0] of TDoublePair;
  end;
  PExtPairData = ^ TExtPairData;

  TExtStringData = record
    Name  : PAnsiString;
    Data  : PAnsiString;
  end;
  PExtStringData = ^ TExtStringData;


  TExtGetCaps           = procedure( var IsInput, IsOutput, IsSlow, IsFast, IsMidi, IsOSC: Integer);              cdecl;
  TExtCreate            = procedure( const aName: AnsiString);                                                    cdecl;
  TExtProc              = procedure;                                                                              cdecl;
  TExtSampleRateChanged = procedure( aSystemRate, aControlRate: Double);                                          cdecl;
  TExtTuningChanged     = procedure( const aReferenceA, aNotesPerOctave, aMiddleNote: Double);                    cdecl;
  TExtSetStringValue    = procedure( const aName: AnsiString; const aValue: AnsiString);                          cdecl;
  TExtGetStringValue    = function ( const aName: AnsiString): PAnsiString;                                       cdecl;
  TExtSetValue          = procedure( const aName: AnsiString; const aValue: Double);                              cdecl;
  TExtGetValue          = function ( const aName: AnsiString): Double;                                            cdecl;
  TExtTick              = procedure( const anInputs: PExtData; const anOutputs: PExtData);                        cdecl;
  TExtGetName           = function ( const anIdex: Integer): PAnsiString;                                         cdecl;
  TExtGetSignalCount    = function: Integer;                                                                      cdecl;
  TExtGetSignalData     = procedure( const anIndex: Integer; out aData: PExtData);                                cdecl;
  TExtGetData           = procedure( const anIndex: Integer; out aData: PExtData);                                cdecl;
  TExtGetPairData       = procedure( const anIndex: Integer; out aData: PExtPairData);                            cdecl;
  TExtGetStringData     = procedure( const anIndex: Integer; out aData: PExtStringData);                          cdecl;


  TModExternal = class( TMod) // Base class for external modules, in a DLL for instance
  private
    FExternalName : string; // Could be a filename for instance
  private
    // The functions the external code (sh|c)ould implement
    FOnGetCaps           : TExtGetCaps;
    FOnCreate            : TExtCreate;
    FOnDestroy           : TExtProc;
    FOnSetDefaults       : TExtProc;
    FOnSampleRateChanged : TExtSampleRateChanged;
    FOnTuningChanged     : TExtTuningChanged;
    FOnSetStringValue    : TExtSetStringValue;
    FOnGetStringValue    : TExtGetStringValue;
    FOnSetInternal       : TExtSetValue;
    FOnGetInternal       : TExtGetValue;
    FOnDoTick            : TExtTick;
    FOnDoSlowTick        : TExtTick;
    FOnInputName         : TExtGetName;
    FOnOutputName        : TExtGetName;
    FOnGetSignalCount    : TExtGetSignalCount;
    FOnGetLightsCount    : TExtGetSignalCount;
    FOnGetDataCount      : TExtGetSignalCount;
    FOnGetXYDataCount    : TExtGetSignalCount;
    FOnGetInfoCount      : TExtGetSignalCount;
    FOnGetCursorCount    : TExtGetSignalCount;
    FOnGatherSignals     : TExtGetSignalData;
    FOnGatherLights      : TExtGetSignalData;
    FOnGatherData        : TExtGetData;
    FOnGatherXYData      : TExtGetPairData;
    FOnGatherInfo        : TExtGetStringData;
    FOnGatherCursorData  : TExtGetData;
    // End of external functions list
  protected
    procedure   BindFunctions;                                                                                  virtual;
    procedure   UnbindFunctions;                                                                                virtual;
  protected
    procedure   SetExternalName( const aValue: string);                                                         virtual;
  public
    procedure   Initialize;                                                                                    override;
    destructor  Destroy;                                                                                       override;
    procedure   SetDefaults;                                                                                   override;
    procedure   SampleRateChanged;                                                                             override;
    procedure   TuningChanged;                                                                                 override;
    procedure   SetStringValue( const aName, aValue: string);                                                  override;
    function    GetStringValue( const aName: string): string;                                                  override;
    procedure   SetInternal   ( const aName: string; aValue: TSignal);                                         override;
    function    GetInternal   ( const aName: string): TSignal;                                                 override;
    procedure   DoTick;                                                                                        override;
    procedure   DoSlowTick;                                                                                    override;
    function    InputName ( anIndex: Integer): string;                                                         override;
    function    OutputName( anIndex: Integer): string;                                                         override;
    procedure   GatherSignals   ( const aPrefix: string; const aCallback: TSignalHandler    );                 override;
    procedure   GatherLights    ( const aPrefix: string; const aCallback: TLightsHandler    );                 override;
    procedure   GatherData      ( const aPrefix: string; const aCallback: TDataHandler      );                 override;
    procedure   GatherXYData    ( const aPrefix: string; const aCallback: TXYDataHandler    );                 override;
    procedure   GatherInfo      ( const aPrefix: string; const aCallback: TInfoHandler      );                 override;
    procedure   GatherCursorData( const aPrefix: string; const aCallback: TCursorDataHandler);                 override;
  public
    property    ExternalName: string read FExternalName write SetExternalName;
  end;


  TModDll = class( TModExternal)
  private
    FDllHandle : Cardinal;
  protected
    procedure   BindFunctions;                                                                                 override;
    procedure   UnbindFunctions;                                                                               override;
  end;


implementation


{ ========
  TModExternal = class( TMod) // Base class for external modules, in a DLL for instance
  private
    FExternalName : string; // Could be a filename for instance
  public
    property    ExternalName: string read FExternalName write SetExternalName;
  protected
}

    procedure   TModExternal.BindFunctions; // virtual;
    begin
      // For childeren ...
    end;


    procedure   TModExternal.UnbindFunctions; // virtual;
    begin
      // For childeren ...
    end;


//  protected

    procedure   TModExternal.SetExternalName( const aValue: string); // virtual;
    begin
      if aValue <> FExternalName
      then FExternalName := aValue;
    end;


//  public

    procedure   TModExternal.Initialize; // override;
    var
      IIsInput  : Integer;
      IIsOutput : Integer;
      IIsSlow   : Integer;
      IIsFast   : Integer;
      IIsMidi   : Integer;
      IIsOSC    : Integer;
    begin
      Locked := True;

      try
        BindFunctions;

        if Assigned( FOnGetCaps)
        then begin
          FOnGetCaps( IIsInput, IIsOutput, IIsSlow, IIsFast, IIsMidi, IIsOSC);
          FIsInput  := IIsInput  <> 0;
          FIsOutput := IIsOutput <> 0;
          FIsFast   := IIsFast   <> 0;
          FIsSlow   := IIsSlow   <> 0;
          FIsMidi   := IIsMidi   <> 0;
          FIsOSC    := IIsOSC    <> 0;
        end;

        if Assigned( FOnCreate)
        then FOnCreate( AnsiString( Name));

        inherited;
      finally
        Locked := False;
      end;
    end;


    destructor  TModExternal.Destroy; // override;
    begin
      Locked := True;

      if Assigned( FOnDestroy)
      then FOnDestroy;

      UnbindFunctions;
      inherited;
    end;


    procedure   TModExternal.SetDefaults; // override;
    begin
      if Assigned( FOnSetDefaults)
      then FOnSetDefaults;
    end;


    procedure   TModExternal.SampleRateChanged; // override;
    begin
      if Assigned( FOnSampleRateChanged)
      then begin
        Locked := True;

        try
          FOnSampleRateChanged( System_Rate, Control_Rate);
        finally
          Locked := False;
        end;
      end;
    end;


    procedure   TModExternal.TuningChanged; // override;
    begin
      if Assigned( FOnTuningChanged)
      then begin
        Locked := True;

        try
          FOnTuningChanged( ReferenceA, NotesPerOctave, MiddleNote);
        finally
          Locked := False;
        end;
      end;
    end;


    procedure   TModExternal.SetStringValue( const aName, aValue: string); // override;
    begin
      if Assigned( FOnSetStringValue)
      then FOnSetStringValue( AnsiString( aName), AnsiString( aValue));
    end;


    function    TModExternal.GetStringValue( const aName: string): string; // override;
    begin
      if Assigned( FOnGetStringValue)
      then Result := string( FOnGetStringValue( AnsiString( aName)))
      else Result := '';
    end;


    procedure   TModExternal.SetInternal( const aName: string; aValue: TSignal); // override;
    begin
      if Assigned( FOnSetInternal)
      then FOnSetInternal( AnsiString( aName), aValue);
    end;


    function    TModExternal.GetInternal( const aName: string): TSignal; // override;
    begin
      if Assigned( FOnGetInternal)
      then Result := FOnGetInternal( AnsiString( aName))
      else Result := UNDEFINED;
    end;


    procedure   TModExternal.DoTick; // override;
    var
      i        : Integer;
      PInData  : PExtData;
      POutData : PExtData;
    begin
      if Assigned( FOnDoTick)
      then begin
        GetMem( PInData , SizeOf( TExtData) + ( InputCount  - 1) * SizeOf( Double));
        GetMem( POutData, SizeOf( TExtData) + ( OutputCount - 1) * SizeOf( Double));

        try
          PInData^.Name   := nil;
          PInData^.Count  := InputCount;
          POutData^.Name  := nil;
          POutData^.Count := OutputCount;

          for i := 0 to InputCount - 1
          do PLongData( @ PInData^.Data)^[ i] := FInputs[ i];

          FOnDoTick( PInData, POutData);

          for i := 0 to OutputCount - 1
          do FOutputs[ i] := PLongData( @ POutData^.Data)^[ i]
        finally
          FreeMem( PInData );
          FreeMem( POutData);
        end;
      end;
    end;


    procedure   TModExternal.DoSlowTick; // override;
    var
      i        : Integer;
      PInData  : PExtData;
      POutData : PExtData;
    begin
      if Assigned( FOnDoSlowTick)
      then begin
        GetMem( PInData , SizeOf( TExtData) + ( InputCount  - 1) * SizeOf( Double));
        GetMem( POutData, SizeOf( TExtData) + ( OutputCount - 1) * SizeOf( Double));

        try
          PInData^.Name   := nil;
          PInData^.Count  := InputCount;
          POutData^.Name  := nil;
          POutData^.Count := OutputCount;

          for i := 0 to InputCount - 1
          do PLongData( @ PInData^.Data)^[ i] := FInputs[ i];

          FOnDoSlowTick( PInData, POutData);

          for i := 0 to OutputCount - 1
          do FOutputs[ i] := PLongData( @ POutData^.Data)^[ i]
        finally
          FreeMem( PInData );
          FreeMem( POutData);
        end;
      end;
    end;


    function    TModExternal.InputName( anIndex: Integer): string; // override;
    begin
      if Assigned( FOnInputName)
      then begin
        Result := string( FOnInputName( anIndex));

        if Result = ''
        then Result := NO_INPUT;
      end
      else Result := NO_INPUT;
    end;


    function    TModExternal.OutputName( anIndex: Integer): string; // override;
    begin
      if Assigned( FOnOutputName)
      then begin
        Result := string( FOnOutputName( anIndex));

        if Result = ''
        then Result := NO_OUTPUT;
      end
      else Result := NO_OUTPUT;
    end;


    procedure   TModExternal.GatherSignals( const aPrefix: string; const aCallback: TSignalHandler); // override;
    var
      aCount : Integer;
      aData  : PExtData;
    begin
      if Assigned( FOnGatherSignals) and Assigned( FOnGetSignalCount) and Assigned( aCallback)
      then begin
        aCount := FOnGetSignalCount;

        while( aCount > 0)
        do begin
          Dec( aCount);
          aData := nil;
          FOnGatherSignals( aCount, aData);

          if Assigned( aData) and Assigned( aData^.Name) and ( aData^.Count > 0)
          then aCallback( Self, MakeInfo( aPrefix, Name, string( aData^.Name), aData^.Data[ 0]));
        end;
      end;
    end;


    procedure   TModExternal.GatherLights( const aPrefix: string; const aCallback: TLightsHandler); // override;
    var
      aCount : Integer;
      aData  : PExtData;
    begin
      if Assigned( FOnGatherLights) and Assigned( FOnGetLightsCount) and Assigned( aCallback)
      then begin
        aCount := FOnGetLightsCount;

        while( aCount > 0)
        do begin
          Dec( aCount);
          aData := nil;
          FOnGatherLights( aCount, aData);

          if Assigned( aData) and Assigned( aData^.Name) and ( aData.Count > 0)
          then aCallback( Self, MakeInfo( aPrefix, Name, string( aData^.Name), aData^.Data[ 0]));
        end;
      end;
    end;


    procedure   TModExternal.GatherData( const aPrefix: string; const aCallback: TDataHandler); // override;
    var
      i       : Integer;
      aCount  : Integer;
      aData   : PExtData;
      aValues : TSignalArray;
    begin
      if Assigned( FOnGatherData) and Assigned( FOnGetDataCount) and Assigned( aCallback)
      then begin
        aCount := FOnGetDataCount;

        while( aCount > 0)
        do begin
          Dec( aCount);
          aData := nil;
          FOnGatherData( aCount, aData);

          if Assigned( aData) and Assigned( aData^.Name) and ( aData^.Count > 0)
          then begin
            SetLength( aValues, aData^.Count);

            for i := 0 to Length( aValues) - 1
            do aValues[ i] := PLongData( @ aData^.Data)^[ i];

            aCallback( Self, MakeInfo( aPrefix, Name, string( aData^.Name), aValues));
          end;
        end;
      end;
    end;


    procedure   TModExternal.GatherXYData( const aPrefix: string; const aCallback: TXYDataHandler); // override;
    var
      i       : Integer;
      aCount  : Integer;
      aData   : PExtPairData;
      aValues : TSignalPairFifo;
    begin
      if Assigned( FOnGatherXYData) and Assigned( FOnGetXYDataCount) and Assigned( aCallback)
      then begin
        aCount := FOnGetXYDataCount;

        while( aCount > 0)
        do begin
          Dec( aCount);
          aData := nil;
          FOnGatherXYData( aCount, aData);

          if Assigned( aData) and Assigned( aData^.Name) and ( aData^.Count > 0)
          then begin
            aValues := TSignalPairFifo.Create( aData.Count);

            try
              for i := 0 to aValues.Size - 1
              do aValues.Append( SignalPair( PLongPairData( @ aData^.Data)^[ i].X, PLongPairData( @ aData^.Data)^[ i].Y));

              aCallback( Self, MakeInfo( aPrefix, Name, string( aData^.Name), aValues));
            finally
              aValues.DisposeOf;
            end;
          end;
        end;
      end;
    end;


    procedure   TModExternal.GatherInfo( const aPrefix: string; const aCallback: TInfoHandler); // override;
    var
      aCount : Integer;
      aData  : PExtStringData;
    begin
      if Assigned( FOnGatherInfo) and Assigned( FOnGetInfoCount) and Assigned( aCallback)
      then begin
        aCount := FOnGetInfoCount;

        while aCount > 0
        do begin
          Dec( aCount);

          FOnGatherInfo( aCount, aData);

          if( Assigned( aData) and Assigned( aData^.Name) and Assigned( aData^.Data))
          then aCallback( Self, MakeInfo( aPrefix, Name, string( aData^.Name), string( aData^.Data)));
        end;
      end;
    end;


    procedure   TModExternal.GatherCursorData( const aPrefix: string; const aCallback: TCursorDataHandler); // override;
    var
      aCount : Integer;
      aData  : PExtData;
      aValue : TSignalPair;
    begin
      if Assigned( FOnGatherCursorData) and Assigned( FOnGetCursorCount) and Assigned( aCallback)
      then begin
        aCount := FOnGetCursorCount;

        while aCount > 0
        do begin
          Dec( aCount);
          aData := nil;
          FOnGatherCursorData( aCount, aData);

          if Assigned( aData) and Assigned( aData^.Name) and ( aData^.Count > 1)
          then begin
            aValue.X := PLongData( @ ( aData^.Data))[ 0];
            aValue.Y := PLongData( @ ( aData^.Data))[ 1];
            aCallback( Self, MakeInfo( aPrefix, Name, string( aData^.Name), aValue));
          end;
        end;
      end;
    end;


{ ========
  TModDll = class( TModExternal)
  protected
}

    procedure   TModDll.BindFunctions; // override;
    begin
      if FileExists( ExternalName)
      then begin
        FDllHandle := LoadLibrary( PWideChar( ExternalName));

        if FDllHandle <> 0
        then begin
          @ FOnGetCaps           := GetProcAddress( FDllHandle, 'GetCaps'          );
          @ FOnCreate            := GetProcAddress( FDllHandle, 'Create'           );
          @ FOnDestroy           := GetProcAddress( FDllHandle, 'Destroy'          );
          @ FOnSetDefaults       := GetProcAddress( FDllHandle, 'SetDefaults'      );
          @ FOnSampleRateChanged := GetProcAddress( FDllHandle, 'SampleRateChanged');
          @ FOnTuningChanged     := GetProcAddress( FDllHandle, 'TuningChanged'    );
          @ FOnSetStringValue    := GetProcAddress( FDllHandle, 'SetStringValue'   );
          @ FOnGetStringValue    := GetProcAddress( FDllHandle, 'GetStringValue'   );
          @ FOnSetInternal       := GetProcAddress( FDllHandle, 'SetInternal'      );
          @ FOnGetInternal       := GetProcAddress( FDllHandle, 'GetInternal'      );
          @ FOnDoTick            := GetProcAddress( FDllHandle, 'DoTick'           );
          @ FOnDoSlowTick        := GetProcAddress( FDllHandle, 'DoSlowTick'       );
          @ FOnInputName         := GetProcAddress( FDllHandle, 'InputName'        );
          @ FOnOutputName        := GetProcAddress( FDllHandle, 'OutputName'       );
          @ FOnGetSignalCount    := GetProcAddress( FDllHandle, 'GetSignalCount'   );
          @ FOnGetLightsCount    := GetProcAddress( FDllHandle, 'GetLightsCount'   );
          @ FOnGetDataCount      := GetProcAddress( FDllHandle, 'GetDataCount'     );
          @ FOnGetXYDataCount    := GetProcAddress( FDllHandle, 'GetXYDataCount'   );
          @ FOnGetInfoCount      := GetProcAddress( FDllHandle, 'GetInfoCount'     );
          @ FOnGetCursorCount    := GetProcAddress( FDllHandle, 'GetCursoeCount'   );
          @ FOnGatherSignals     := GetProcAddress( FDllHandle, 'GatherSignals'    );
          @ FOnGatherLights      := GetProcAddress( FDllHandle, 'GatherLights'     );
          @ FOnGatherData        := GetProcAddress( FDllHandle, 'GatherData'       );
          @ FOnGatherXYData      := GetProcAddress( FDllHandle, 'GatherXYData'     );
          @ FOnGatherInfo        := GetProcAddress( FDllHandle, 'GatherInfo'       );
          @ FOnGatherCursorData  := GetProcAddress( FDllHandle, 'GatherCursorData' );
        end;
      end;
    end;


    procedure   TModDll.UnbindFunctions; // override;
    begin
      if FDllHandle <> 0
      then FreeLibrary( FDllHandle);
    end;


end.

